org.apache.catalina

## Interface AccessLog

- All Known Implementing Classes:
    AccessLogAdapter, AccessLogValve, ExtendedAccessLogValve, JDBCAccessLogValve, StandardEngine.NoopAccessLog

      public interface AccessLog

  Intended for use by a `Valve` to indicate that the `Valve` provides access logging. It is used by the Tomcat internals to identify a Valve that logs access requests so requests that are rejected earlier in the processing chain can still be added to the access log. Implementations of this interface should be robust against the provided `Request` and `Response` objects being null, having null attributes or any other 'oddness' that may result from attempting to log a request that was almost certainly rejected because it was mal-formed.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `PROTOCOL_ATTRIBUTE` Name of request attribute used to override the protocol recorded by the AccessLog.
    `static String` | `REMOTE_ADDR_ATTRIBUTE` Name of request attribute used to override the remote address recorded by the AccessLog.
    `static String` | `REMOTE_HOST_ATTRIBUTE` Name of request attribute used to override remote host name recorded by the AccessLog.
    `static String` | `SERVER_PORT_ATTRIBUTE` Name of request attribute used to override the server port recorded by the AccessLog.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `getRequestAttributesEnabled()`
    `void` | `log(Request request, Response response, long time)` Add the request/response to the access log using the specified processing time.
    `void` | `setRequestAttributesEnabled(boolean requestAttributesEnabled)` Should this valve set request attributes for IP address, Hostname, protocol and port used for the request?

- - ### Field Detail

    - #### REMOTE_ADDR_ATTRIBUTE

          static final String REMOTE_ADDR_ATTRIBUTE

      Name of request attribute used to override the remote address recorded by the AccessLog.
      See Also:
        Constant Field Values

    - #### REMOTE_HOST_ATTRIBUTE

          static final String REMOTE_HOST_ATTRIBUTE

      Name of request attribute used to override remote host name recorded by the AccessLog.
      See Also:
        Constant Field Values

    - #### PROTOCOL_ATTRIBUTE

          static final String PROTOCOL_ATTRIBUTE

      Name of request attribute used to override the protocol recorded by the AccessLog.
      See Also:
        Constant Field Values

    - #### SERVER_PORT_ATTRIBUTE

          static final String SERVER_PORT_ATTRIBUTE

      Name of request attribute used to override the server port recorded by the AccessLog.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### log

          void log(Request request,
                 Response response,
                 long time)

      Add the request/response to the access log using the specified processing time.
      Parameters:
        `request` - Request (associated with the response) to log
        `response` - Response (associated with the request) to log
        `time` - Time taken to process the request/response in milliseconds (use 0 if not known)

    - #### setRequestAttributesEnabled

          void setRequestAttributesEnabled(boolean requestAttributesEnabled)

      Should this valve set request attributes for IP address, Hostname, protocol and port used for the request? This are typically used in conjunction with the `AccessLogValve` which will otherwise log the original values. Default is `true`. The attributes set are:
      - org.apache.catalina.RemoteAddr
      - org.apache.catalina.RemoteHost
      - org.apache.catalina.Protocol
      - org.apache.catalina.ServerPost
      Parameters:
        `requestAttributesEnabled` - `true` causes the attributes to be set, `false` disables the setting of the attributes.

    - #### getRequestAttributesEnabled

          boolean getRequestAttributesEnabled()

      Returns:
        `true` if the attributes will be logged, otherwise `false`
      See Also:
        `setRequestAttributesEnabled(boolean)`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.